var CountUp = Backbone.Collection.extend({
  model: App.Model.Score,
  initialize: function () {
    this.on('add', function (score) {
      if (this.length > App.Collection.Players.length * 8 * 3) {
        this.pop(score);
        if (window.confirm('GAME END')) {
          App.Router.CountUp.End();
        }
      }
    });
  },
  now_player: function (options) {
    options = options || {};
    var count = _.isNumber(options.count) ? options.count : this.length;
    count = (0 >= count) ? 1 : count;
    var players_length = App.Collection.Players.length;
    while (count >= players_length * 3) {
      count -= players_length * 3;
    }
    var index = Math.floor(count / 3);
    return App.Collection.Players.models[index];
  },
  now_round: function (options) {
    options = options || {};
    var count = _.isNumber(options.count) ? options.count : this.length;
    count = (0 >= count) ? 1 : count;
    var players_length = App.Collection.Players.length;
    var round = Math.floor(count / players_length / 3);
    return round;
  },
  game_data: function () {
    var count   = this.length;
    var players = App.Collection.Players.models;
    var throw_count = 0;
    var game_data = [];
    var now_player, now_round, player_index = 0;
    for (var i = 0; count > i; i++, throw_count++) {
      if (throw_count === 3) throw_count = 0;
      now_round = this.now_round({count: i});
      now_player = players.indexOf(this.now_player({count: i}));
      game_data[now_player] = game_data[now_player] || [];
      game_data[now_player][now_round] = game_data[now_player][now_round] || [];
      game_data[now_player][now_round][throw_count] = game_data[now_player][now_round][throw_count] || [];
      game_data[now_player][now_round][throw_count] = this.models[i];
    }
    return game_data;
  },
  game_score: function () {
    var players = App.Collection.Players.models;
    var game_data = this.game_data();
    var now_player = players.indexOf(this.now_player({count: this.length - 1}));
    var game_score = {};
    var i = 0;
    game_score.now_player = now_player;
    game_score.dart_result = [];
    game_score.score_round = [];
    game_score.player_score = [];
    // Dart Result
    for (i = 0; 3 > i; i++) {
      try {
        game_score.dart_result[i] = _.last(game_data[now_player])[i].get('label');
      } catch(e) {
        game_score.dart_result[i] = '- ' + (i + 1) +' -';
      }
    }
    // Score Round
    for (i = 0; 8 > i; i++) {
      try {
          game_score.score_round[i]  = game_data[now_player][i][0].get('point') || 0;
          game_score.score_round[i] += game_data[now_player][i][1].get('point') || 0;
          game_score.score_round[i] += game_data[now_player][i][2].get('point') || 0;
      } catch(e) {
        game_score.score_round[i] = _.isNumber(game_score.score_round[i]) ?
          game_score.score_round[i] : '';
      }
    }
    // Player Score
    for (var index = 0; players.length > index; index++) {
      for (i = 0; 8 > i; i++) {
        try {
            game_score.player_score[index] = game_score.player_score[index] || 0;
            game_score.player_score[index] += game_data[index][i][0].get('point') || 0;
            game_score.player_score[index] += game_data[index][i][1].get('point') || 0;
            game_score.player_score[index] += game_data[index][i][2].get('point') || 0;
        } catch(e) {
          game_score.player_score[index] = _.isNumber(game_score.player_score[index]) ?
            game_score.player_score[index] : 0;
        }
      }
    }
    return game_score;
  }
});

App.Collection.CountUp = new CountUp();
